Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalCollection.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalCollection.cs	(revision 17505)
+++ branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalCollection.cs	(revision 17506)
@@ -33,5 +33,5 @@
       get => HeuristicLab.Common.Resources.VSImageLibrary.Object;
     }
-    private IDictionary<string, Interval> VariableIntervals { get; } = new Dictionary<string, Interval>();
+    private IDictionary<string, Interval> intervals { get; } = new Dictionary<string, Interval>();
 
     [Storable(Name = "StorableIntervalInformation")]
@@ -39,5 +39,5 @@
       get {
         var l = new List<KeyValuePair<string, double[]>>();
-        foreach (var varInt in VariableIntervals)
+        foreach (var varInt in intervals)
 
           l.Add(new KeyValuePair<string, double[]>(varInt.Key,
@@ -48,5 +48,5 @@
       set {
         foreach (var varInt in value)
-          VariableIntervals.Add(varInt.Key, new Interval(varInt.Value[0], varInt.Value[1]));
+          intervals.Add(varInt.Key, new Interval(varInt.Value[0], varInt.Value[1]));
       }
     }
@@ -57,6 +57,6 @@
 
     protected IntervalCollection(IntervalCollection original, Cloner cloner) : base(original, cloner) {
-      foreach (var keyValuePair in original.VariableIntervals) {
-        VariableIntervals.Add(keyValuePair.Key, new Interval(keyValuePair.Value.LowerBound, keyValuePair.Value.UpperBound));
+      foreach (var keyValuePair in original.intervals) {
+        intervals.Add(keyValuePair.Key, new Interval(keyValuePair.Value.LowerBound, keyValuePair.Value.UpperBound));
       }
     }
@@ -65,28 +65,28 @@
     }
 
-    public IntervalCollection(IDictionary<string, Interval> variableIntervals) {
-      this.VariableIntervals = variableIntervals;
+    public IntervalCollection(IDictionary<string, Interval> intervals) {
+      this.intervals = intervals;
     }
 
-    public Interval GetInterval(string variable) {
-      if (!VariableIntervals.ContainsKey(variable)) throw new ArgumentException($"The given variable:{ variable } is not present!");
+    public Interval GetInterval(string identifier) {
+      if (!intervals.ContainsKey(identifier)) throw new ArgumentException($"The given identifier:{ identifier } is not present!");
 
-      return VariableIntervals[variable];
+      return intervals[identifier];
     }
 
-    public void SetInterval(string key, Interval interval) {
-      VariableIntervals[key] = interval;
+    public void SetInterval(string identifier, Interval interval) {
+      intervals[identifier] = interval;
     }
 
-    public void AddInterval(string key, Interval interval) {
-      VariableIntervals.Add(key, interval);
+    public void AddInterval(string identifier, Interval interval) {
+      intervals.Add(identifier, interval);
     }
 
-    public void DeleteInterval(string key) {
-      VariableIntervals.Remove(key);
+    public void DeleteInterval(string identifier) {
+      intervals.Remove(identifier);
     }
 
     public IDictionary<string, Interval> GetIntervals() {
-      return VariableIntervals;
+      return intervals;
     }
   }
Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraint.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraint.cs	(revision 17505)
+++ branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraint.cs	(revision 17506)
@@ -20,7 +20,7 @@
 #endregion
 using System;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Problems.DataAnalysis {
@@ -60,5 +60,5 @@
     public string Target {
       get => target;
-      set {
+      private set {
         if (target == value) return;
         target = value;
@@ -68,16 +68,16 @@
     }
 
-    public bool IsDerivation {
-      get => numberOfDerivation > 0;
+    public bool IsDerivative {
+      get => NumberOfDerivations > 0;
     }
 
     [Storable]
-    private int numberOfDerivation;
-    public int NumberOfDerivation {
-      get => numberOfDerivation;
+    private int numberOfDerivations;
+    public int NumberOfDerivations {
+      get => numberOfDerivations;
       set {
         if (value < 0 || value > 3) throw new ArgumentException("Number of derivation has to be between 0 - 3.");
-        if (numberOfDerivation == value) return;
-        numberOfDerivation = value;
+        if (numberOfDerivations == value) return;
+        numberOfDerivations = value;
         UpdateExpression();
         OnChanged();
@@ -111,9 +111,9 @@
     private IntervalConstraint(StorableConstructorFlag _) : base(_) { }
 
-    public IntervalConstraint(string expression, string variable, string target, int numberOfDerivation, Interval interval, bool enabled) : base(){
+    public IntervalConstraint(string expression, string variable, string target, int numberOfDerivations, Interval interval, bool enabled) : base(){
       this.expression = expression;
       this.variable = variable;
       this.target = target;
-      this.numberOfDerivation = numberOfDerivation;
+      this.numberOfDerivations = numberOfDerivations;
       this.interval = interval;
       this.enabled = enabled;
@@ -129,5 +129,5 @@
       this.Variable = original.Variable;
       this.Target = original.Target;
-      this.NumberOfDerivation = original.NumberOfDerivation;
+      this.NumberOfDerivations = original.NumberOfDerivations;
       this.Interval = original.Interval;
       this.Enabled = original.Enabled;
@@ -157,5 +157,5 @@
       var expression = "";
 
-      if (!IsDerivation) {
+      if (!IsDerivative) {
         expression = string.Format("Target:{0} in {1}{2} .. {3}{4}",
           Variable,
@@ -174,13 +174,13 @@
         Interval?.UpperBound,
         "]",
-        GetDerivationString(numberOfDerivation));
+        GetDerivationString(numberOfDerivations));
         Expression = expression;
     }
 
     private string GetDefinitionString() {
-      if (!IsDerivation) {
+      if (!IsDerivative) {
         return "Target " + Variable;
       }
-      var definition = $"∂{GetDerivationString(numberOfDerivation)}Target/∂{Variable}{GetDerivationString(numberOfDerivation)}";
+      var definition = $"∂{GetDerivationString(numberOfDerivations)}Target/∂{Variable}{GetDerivationString(numberOfDerivations)}";
       return definition;
     }
Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 17505)
+++ branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 17506)
@@ -23,9 +23,9 @@
 using System.Collections.Generic;
 using System.Linq;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 
 namespace HeuristicLab.Problems.DataAnalysis {
@@ -94,5 +94,5 @@
       problemData.Parameters.Add(new ConstrainedValueParameter<StringValue>(TargetVariableParameterName, new ItemSet<StringValue>()));
       problemData.Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, "", new IntervalCollection()));
-      problemData.Parameters.Add(new FixedValueParameter<ProblemDataConstraint>(IntervalConstraintsParameterName, "", new ProblemDataConstraint()));
+      problemData.Parameters.Add(new FixedValueParameter<ProblemDataConstraint>(IntervalConstraintsParameterName, "", new ProblemDataConstraint(problemData)));
       emptyProblemData = problemData;
     }
Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/ProblemDataConstraint.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/ProblemDataConstraint.cs	(revision 17505)
+++ branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/ProblemDataConstraint.cs	(revision 17506)
@@ -35,5 +35,5 @@
     private static readonly string exampleInput = "# Example for a target variable constraint:" + Environment.NewLine +
                                                   "Target:'y' in [0 .. 100]" + Environment.NewLine + Environment.NewLine +
-                                                  "# Example for constraint on model parameter: " + Environment.NewLine +
+                                                  "# Example for constraints on model parameters: " + Environment.NewLine +
                                                   "d'y'/d'x' in [0 .. 10]" + Environment.NewLine +
                                                   "∂²'y'/∂'x'² in [-1 .. inf.]";