Index: branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/DirectScheduleGTCrossoverTest.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/DirectScheduleGTCrossoverTest.cs	(revision 17515)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/DirectScheduleGTCrossoverTest.cs	(revision 17516)
@@ -20,7 +20,5 @@
 #endregion
 
-using System.Linq;
 using HeuristicLab.Core;
-using HeuristicLab.Encodings.ScheduleEncoding;
 using HeuristicLab.Tests;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
@@ -47,5 +45,5 @@
       Schedule actual;
       actual = DirectScheduleGTCrossover.Apply(random, parent1, parent2, jobData, mutProp);
-      Schedule expected = DirectScheduleRandomCreator.Apply(new PWREncoding(3, 3, new TestRandom(new int[] { 0, 2, 1, 1, 0, 2, 1, 2, 0 }, null)), TestUtils.CreateJobData());
+      Schedule expected = DirectScheduleRandomCreator.Apply(new PWR(3, 3, new TestRandom(new int[] { 0, 2, 1, 1, 0, 2, 1, 2, 0 }, null)), TestUtils.CreateJobData());
       Assert.IsTrue(TestUtils.ScheduleEquals(actual, expected));
     }
Index: branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMJOXCrossoverTest.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMJOXCrossoverTest.cs	(revision 17515)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMJOXCrossoverTest.cs	(revision 17516)
@@ -40,7 +40,7 @@
     public void ApplyTest() {
       IRandom random = new TestRandom(new int[] { 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1 }, null);
-      JSMEncoding p1 = TestUtils.CreateTestJSM1();
-      JSMEncoding p2 = TestUtils.CreateTestJSM2();
-      JSMEncoding expected = new JSMEncoding(0);
+      JSM p1 = TestUtils.CreateTestJSM1();
+      JSM p2 = TestUtils.CreateTestJSM2();
+      JSM expected = new JSM(0);
       ItemList<Permutation> jsm = expected.JobSequenceMatrix;
       for (int i = 0; i < 6; i++) {
@@ -49,5 +49,5 @@
 
 
-      JSMEncoding actual;
+      JSM actual;
       actual = JSMJOXCrossover.Apply(random, p1, p2);
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMSXXCrossoverTest.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMSXXCrossoverTest.cs	(revision 17515)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMSXXCrossoverTest.cs	(revision 17516)
@@ -40,7 +40,7 @@
     public void ApplyTest() {
       IRandom random = new TestRandom(new int[] { 0, 3 }, null);
-      JSMEncoding p1 = TestUtils.CreateTestJSM1();
-      JSMEncoding p2 = TestUtils.CreateTestJSM2();
-      JSMEncoding expected = new JSMEncoding(0);
+      JSM p1 = TestUtils.CreateTestJSM1();
+      JSM p2 = TestUtils.CreateTestJSM2();
+      JSM expected = new JSM(0);
       ItemList<Permutation> jsm = expected.JobSequenceMatrix;
       for (int i = 0; i < 6; i++) {
@@ -48,5 +48,5 @@
       }
 
-      JSMEncoding actual;
+      JSM actual;
       actual = JSMSXXCrossover.Apply(random, p1, p2);
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMShiftChangeManipulatorTest.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMShiftChangeManipulatorTest.cs	(revision 17515)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMShiftChangeManipulatorTest.cs	(revision 17516)
@@ -40,7 +40,7 @@
     public void ApplyTest() {
       IRandom random = new TestRandom(new int[] { 2, 1, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2 }, null);
-      JSMEncoding individual = TestUtils.CreateTestJSM1();
+      JSM individual = TestUtils.CreateTestJSM1();
       JSMShiftChangeManipulator.Apply(random, individual);
-      JSMEncoding expected = new JSMEncoding(0);
+      JSM expected = new JSM(0);
       ItemList<Permutation> jsm = expected.JobSequenceMatrix;
       for (int i = 0; i < 3; i++) {
Index: branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/PWRGOXCrossoverTest.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/PWRGOXCrossoverTest.cs	(revision 17515)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/PWRGOXCrossoverTest.cs	(revision 17516)
@@ -40,9 +40,9 @@
     public void ApplyTest() {
       IRandom random = new TestRandom(new int[] { 3 }, null);
-      PWREncoding parent1 = TestUtils.CreateTestPWR1();
-      PWREncoding parent2 = TestUtils.CreateTestPWR2();
-      PWREncoding expected = new PWREncoding();
+      PWR parent1 = TestUtils.CreateTestPWR1();
+      PWR parent2 = TestUtils.CreateTestPWR2();
+      PWR expected = new PWR();
       expected.PermutationWithRepetition = new IntegerVector(new int[] { 1, 0, 1, 0, 2, 0, 1, 2, 2 });
-      PWREncoding actual;
+      PWR actual;
       actual = PWRGOXCrossover.Apply(random, parent1, parent2);
       Assert.IsTrue(TestUtils.PRWEncodingEquals(expected, actual));
Index: branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/PWRPPXCrossoverTest.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/PWRPPXCrossoverTest.cs	(revision 17515)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/PWRPPXCrossoverTest.cs	(revision 17516)
@@ -40,9 +40,9 @@
     public void ApplyTest() {
       IRandom random = new TestRandom(new int[] { 1, 1, 0, 0, 1, 1, 0, 0, 1 }, null);
-      PWREncoding parent1 = TestUtils.CreateTestPWR1();
-      PWREncoding parent2 = TestUtils.CreateTestPWR2();
-      PWREncoding expected = new PWREncoding();
+      PWR parent1 = TestUtils.CreateTestPWR1();
+      PWR parent2 = TestUtils.CreateTestPWR2();
+      PWR expected = new PWR();
       expected.PermutationWithRepetition = new IntegerVector(new int[] { 1, 0, 1, 0, 1, 2, 0, 2, 2 });
-      PWREncoding actual;
+      PWR actual;
       actual = PWRPPXCrossover.Apply(random, parent1, parent2);
       Assert.IsTrue(TestUtils.PRWEncodingEquals(expected, actual));
Index: branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/TestUtils.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/TestUtils.cs	(revision 17515)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/TestUtils.cs	(revision 17516)
@@ -29,6 +29,6 @@
 namespace HeuristicLab.Encodings.ScheduleEncoding.Tests {
   public class TestUtils {
-    public static JSMEncoding CreateTestJSM1() {
-      JSMEncoding result = new JSMEncoding(0);
+    public static JSM CreateTestJSM1() {
+      JSM result = new JSM(0);
       ItemList<Permutation> jsm = result.JobSequenceMatrix;
       for (int i = 0; i < 6; i++)
@@ -37,6 +37,6 @@
     }
 
-    public static JSMEncoding CreateTestJSM2() {
-      JSMEncoding result = new JSMEncoding(0);
+    public static JSM CreateTestJSM2() {
+      JSM result = new JSM(0);
       ItemList<Permutation> jsm = result.JobSequenceMatrix;
       for (int i = 0; i < 6; i++)
@@ -46,6 +46,6 @@
 
 
-    public static PWREncoding CreateTestPWR1() {
-      PWREncoding result = new PWREncoding();
+    public static PWR CreateTestPWR1() {
+      PWR result = new PWR();
       IntegerVector pwr = new IntegerVector(new int[] { 1, 0, 1, 1, 2, 0, 2, 2, 0 });
       result.PermutationWithRepetition = pwr;
@@ -53,6 +53,6 @@
     }
 
-    public static PWREncoding CreateTestPWR2() {
-      PWREncoding result = new PWREncoding();
+    public static PWR CreateTestPWR2() {
+      PWR result = new PWR();
       IntegerVector pwr = new IntegerVector(new int[] { 0, 1, 1, 0, 2, 0, 1, 2, 2 });
       result.PermutationWithRepetition = pwr;
@@ -87,10 +87,10 @@
 
     public static Schedule CreateTestSchedule1() {
-      Schedule result = DirectScheduleRandomCreator.Apply(new PWREncoding(3, 3, new TestRandom(new int[] { 1, 0, 1, 1, 2, 0, 2, 2, 0 }, null)), CreateJobData());
+      Schedule result = DirectScheduleRandomCreator.Apply(new PWR(3, 3, new TestRandom(new int[] { 1, 0, 1, 1, 2, 0, 2, 2, 0 }, null)), CreateJobData());
       return result;
     }
 
     public static Schedule CreateTestSchedule2() {
-      Schedule result = DirectScheduleRandomCreator.Apply(new PWREncoding(3, 3, new TestRandom(new int[] { 0, 1, 1, 0, 2, 0, 1, 2, 2 }, null)), CreateJobData());
+      Schedule result = DirectScheduleRandomCreator.Apply(new PWR(3, 3, new TestRandom(new int[] { 0, 1, 1, 0, 2, 0, 1, 2, 2 }, null)), CreateJobData());
       return result;
     }
@@ -117,5 +117,5 @@
     }
 
-    public static bool JSMEncodingEquals(JSMEncoding expected, JSMEncoding actual) {
+    public static bool JSMEncodingEquals(JSM expected, JSM actual) {
       if (expected.JobSequenceMatrix.Count != actual.JobSequenceMatrix.Count)
         return false;
@@ -136,5 +136,5 @@
     }
 
-    public static bool PRWEncodingEquals(PWREncoding expected, PWREncoding actual) {
+    public static bool PRWEncodingEquals(PWR expected, PWR actual) {
       if (expected.PermutationWithRepetition.Length != actual.PermutationWithRepetition.Length)
         return false;